package eksempel.helper;

import java.awt.*;

public class ConstraintsBuilder {

    private final GridBagConstraints constraints;

    public ConstraintsBuilder() {
        constraints = new GridBagConstraints();
        constraints.fill = GridBagConstraints.HORIZONTAL;
        constraints.insets = new Insets(3, 8, 3, 8);
        constraints.weightx = 1;
        constraints.gridwidth = 1;
    }

    public ConstraintsBuilder weightx(double weightx) {
        constraints.weightx = weightx;
        return this;
    }

    public ConstraintsBuilder gridwidth(int gridwidth) {
        constraints.gridwidth = gridwidth;
        return this;
    }

    public ConstraintsBuilder gridx(int gridx) {
        constraints.gridx = gridx;
        return this;
    }

    public ConstraintsBuilder gridy(int gridy) {
        constraints.gridy = gridy;
        return this;
    }

    public ConstraintsBuilder fill(int fill) {
        constraints.fill = fill;
        return this;
    }

    public GridBagConstraints build() {
        return constraints;
    }
}
