package eksempel.listener;

import javax.swing.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;

// ActionListener til browse knap til at hente fil-sti
public class BrowseAction implements ActionListener {
    private final JFrame parent;
    private final JTextField field;
    private final File defaultDirctory;

    public BrowseAction(JFrame parent, JTextField fileName){
        super();
        this.parent = parent;
        this.field = fileName;
        String defaultDirectoryName = System.getProperty("user.home") + "/testfiler/";
        this.defaultDirctory = new File(defaultDirectoryName);
    }

    public void actionPerformed(ActionEvent e) {
        // vis fil-vælger
        JFileChooser jFileChooser = new JFileChooser();
        if (this.defaultDirctory != null && this.defaultDirctory.exists()) {
            jFileChooser.setCurrentDirectory(defaultDirctory);
        } else {
            jFileChooser.setCurrentDirectory(null);
        }
        jFileChooser.showOpenDialog(parent);
        if (jFileChooser.getSelectedFile() != null) {
            field.setText(jFileChooser.getSelectedFile()
                    .getAbsolutePath());
        }
    }
}
