package eksempel.rest;

import eksempel.rest.ixbrl.RegisterInlineXBRLInput;
import eksempel.rest.ixbrl.RegisterInlineXBRLInvoker;

import javax.swing.*;

class IndlaesInlineXBRLActionListener extends AbstractIndlaesActionListener<RegisterInlineXBRLInput> {
    protected final RegisterInlineXBRLFront gui;

    public IndlaesInlineXBRLActionListener(JFrame parent, RegisterInlineXBRLFront gui) {
        super();
        this.parent = parent;
        this.gui = gui;
    }

    @Override
    protected String derSkalVaelgesDokumentSamtAfsenderCertifikatOgPasswordTekst() {
        return "Der SKAL vælges\n\tInline XBRL dokument\n\tsamt afsender certifikat og password";
    }

    @Override
    protected String kanIkkeLaeseDokumentTekst() {
        return "Kan ikke læse inline XBRL dokument: \n";
    }

    @Override
    protected String invokeRegister(RegisterInlineXBRLInput input) throws Exception {
        return new RegisterInlineXBRLInvoker().register(input, gui.httpsBox.isSelected(), gui.prodRadio.isSelected(), gui.preprodRadio.isSelected(),
                gui.testRadio.isSelected(), gui.devRadio.isSelected(), gui.localRadio.isSelected(), gui.aabenDokumenterBox.isSelected(),
                gui.focesSendFile.getText(), gui.focesSendPw.getText());
    }

    @Override
    protected RegisterInlineXBRLInput samlInput(String indhold, String supplerendeInstans) {
        // Saml input
        RegisterInlineXBRLInput input = new RegisterInlineXBRLInput();
        input.setInlineXbrl(indhold);
        input.setSupplerendeInstans(supplerendeInstans);
        input.setToken(gui.token.getText());
        input.setReturnDocuments(gui.returnerDokumenterBox.isSelected());
        input.setDirigent(gui.ixbrlDirigent.getText());
        input.setGodkendelsesdato(gui.ixbrlGodkendelsesdato.getText());
        return input;
    }

    @Override
    protected String getFilename() {
        return gui.inlineXbrlFile.getText();
    }

    @Override
    protected String getSupplerendeInstansFilnavn() {
        return gui.supplerendeInstansXbrlFile.getText();
    }

    @Override
    protected boolean isAllOk() {
        return gui.inlineXbrlFile.getText() != null && !gui.inlineXbrlFile.getText().equals("")
                && gui.focesSendFile.getText() != null && !gui.focesSendFile.getText().equals("")
                && gui.focesSendPw.getText() != null && !gui.focesSendPw.getText().equals("");
    }
}
