package eksempel.rest;

import eksempel.helper.FileHelper;
import eksempel.rest.xbrl.RegisterXBRLInput;
import eksempel.rest.xbrl.TestXBRLInput;
import eksempel.rest.xbrl.TestXBRLInvoker;

import javax.swing.*;
import java.io.IOException;

public class TestXBRLActionListener extends IndlaesXBRLActionListener {
    public TestXBRLActionListener(JFrame parent, RegisterInlineXBRLFront gui) {
        super(parent, gui);
    }

    @Override
    protected TestXBRLInput samlInput(String indhold, String supplerendeInstans) {
        String pdf = null;
        // Hent PDF indhold
        try {
            pdf = FileHelper.readTextFile(gui.pdfFile.getText().trim());
        } catch (IOException e) {
            errorText = "Kan ikke læse pdf dokument: \n" + e.getMessage();
        }

        // Saml input
        TestXBRLInput input = new TestXBRLInput();
        input.setXbrl(indhold);
        input.setSupplerendeInstans(supplerendeInstans);
        input.setPdf(pdf);
        input.setToken(gui.token.getText());
        input.setTestadgangstegn(gui.testadgangstegn.getText());
        return input;
    }

    @Override
    protected String invokeRegister(RegisterXBRLInput input) throws Exception {
        return new TestXBRLInvoker().register(input, gui.httpsBox.isSelected(), gui.prodRadio.isSelected(), gui.preprodRadio.isSelected(),
                gui.testRadio.isSelected(), gui.devRadio.isSelected(), gui.localRadio.isSelected(), false,
                gui.focesSendFile.getText(), gui.focesSendPw.getText());
    }
}
