package eksempel.rest.ixbrl;

import eksempel.rest.RegisterInput;

import java.util.Base64;

public class RegisterInlineXBRLInput implements RegisterInput<RegisterInlineXBRLBody> {

    private String inlineXbrl = null;
    private String supplerendeInstans;
    private String token;
    private boolean returnDocuments;
    private String dirigent;
    private String godkendelsesdato;

    public String getInlineXbrl() {
        return inlineXbrl;
    }

    public void setInlineXbrl(String inlineXbrl) {
        this.inlineXbrl = inlineXbrl;
    }

    public String getSupplerendeInstans() {
        return supplerendeInstans;
    }

    public void setSupplerendeInstans(String supplerendeInstans) {
        this.supplerendeInstans = supplerendeInstans;
    }

    public String getToken() {
        return token;
    }

    public void setToken(String token) {
        this.token = token;
    }

    public boolean isReturnDocuments() {
        return returnDocuments;
    }

    public void setReturnDocuments(boolean returnDocuments) {
        this.returnDocuments = returnDocuments;
    }

    public String getDirigent() {
        return dirigent;
    }

    public void setDirigent(String dirigent) {
        this.dirigent = dirigent;
    }

    public String getGodkendelsesdato() {
        return godkendelsesdato;
    }

    public void setGodkendelsesdato(String godkendelsesdato) {
        this.godkendelsesdato = godkendelsesdato;
    }

    public RegisterInlineXBRLBody createBody(RegisterInlineXBRLBody body) {
        body.setDestinationErst(true);
        body.setiXbrl(Base64.getEncoder().encodeToString(getInlineXbrl().getBytes()));
        if (getSupplerendeInstans() != null && !getSupplerendeInstans().isEmpty()) {
            body.setSupplerendeInstans(Base64.getEncoder().encodeToString(getSupplerendeInstans().getBytes()));
        }
        if (getToken() != null && !getToken().isEmpty()) {
            body.setToken(getToken());
        }
        body.setReturnDocuments(isReturnDocuments());
        if (getDirigent() != null && !getDirigent().isEmpty()) {
            body.setDirigent(getDirigent());
        }
        if (getGodkendelsesdato() != null && !getGodkendelsesdato().isEmpty()) {
            body.setGodkendelsesdato(getGodkendelsesdato());
        }
        return body;
    }
}
