package eksempel.rest.xbrl;

import eksempel.rest.RegisterInput;

import java.util.Base64;

public class RegisterXBRLInput implements RegisterInput<RegisterXBRLBody> {

    private String xbrl = null;
    private String pdf = null;
    private String supplerendeInstans;
    private String token;
    private boolean destinationErst;

    public String getXbrl() {
        return xbrl;
    }

    public void setXbrl(String xbrl) {
        this.xbrl = xbrl;
    }

    public String getPdf() {
        return pdf;
    }

    public void setPdf(String pdf) {
        this.pdf = pdf;
    }

    public String getSupplerendeInstans() {
        return supplerendeInstans;
    }

    public void setSupplerendeInstans(String supplerendeInstans) {
        this.supplerendeInstans = supplerendeInstans;
    }

    public String getToken() {
        return token;
    }

    public void setToken(String token) {
        this.token = token;
    }

    public boolean isDestinationErst() {
        return destinationErst;
    }

    public void setDestinationErst(boolean destinationErst) {
        this.destinationErst = destinationErst;
    }

    public RegisterXBRLBody createBody(RegisterXBRLBody body) {
        if(body == null) {
            body = new RegisterXBRLBody();
        }
        body.setDestinationErst(true);
        body.setXbrl(Base64.getEncoder().encodeToString(getXbrl().getBytes()));
        body.setPdf(Base64.getEncoder().encodeToString(getPdf().getBytes()));
        if (getSupplerendeInstans() != null && !getSupplerendeInstans().isEmpty()) {
            body.setSupplerendeInstans(Base64.getEncoder().encodeToString(getSupplerendeInstans().getBytes()));
        }
        if (getToken() != null && !getToken().isEmpty()) {
            body.setToken(getToken());
        }
        return body;
    }
}
