package eksempel.rest.xbrl;

import eksempel.rest.RegisterResponse;

import java.util.Arrays;

public class RegisterXBRLResponse implements RegisterResponse {

    String companyCvr;
    String companyName;
    String registrationDate;
    String reportPeriod;
    String statusCode;
    String statusText;
    String statusDetail;
    String uniqueReportIdentifier;
    String token;
    Object[] validationErrors;

    public RegisterXBRLResponse() {
    }

    public String getCompanyCvr() {
        return companyCvr;
    }

    public void setCompanyCvr(String companyCvr) {
        this.companyCvr = companyCvr;
    }

    public String getCompanyName() {
        return companyName;
    }

    public void setCompanyName(String companyName) {
        this.companyName = companyName;
    }

    public String getRegistrationDate() {
        return registrationDate;
    }

    public void setRegistrationDate(String registrationDate) {
        this.registrationDate = registrationDate;
    }

    public String getReportPeriod() {
        return reportPeriod;
    }

    public void setReportPeriod(String reportPeriod) {
        this.reportPeriod = reportPeriod;
    }

    public String getStatusCode() {
        return statusCode;
    }

    public void setStatusCode(String statusCode) {
        this.statusCode = statusCode;
    }

    public String getStatusText() {
        return statusText;
    }

    public void setStatusText(String statusText) {
        this.statusText = statusText;
    }

    public String getStatusDetail() {
        return statusDetail;
    }

    public void setStatusDetail(String statusDetail) {
        this.statusDetail = statusDetail;
    }

    public String getUniqueReportIdentifier() {
        return uniqueReportIdentifier;
    }

    public void setUniqueReportIdentifier(String uniqueReportIdentifier) {
        this.uniqueReportIdentifier = uniqueReportIdentifier;
    }

    public String getToken() {
        return token;
    }

    public void setToken(String token) {
        this.token = token;
    }

    public Object[] getValidationErrors() {
        return validationErrors;
    }

    public void setValidationErrors(Object[] validationErrors) {
        this.validationErrors = validationErrors;
    }

    public String responseInformation() {
        return "Kode: " + getStatusCode() +
                "\nTekst: " + getStatusText() +
                "\nDetaljer:\n" + getStatusDetail() +
                "\nToken: " + getToken() +
                "\nCVR: " + getCompanyCvr() +
                "\nFirma: " + getCompanyName() +
                "\nRegistreringsdato: " + getRegistrationDate() +
                "\nRapporteringsperiode: " + getReportPeriod() +
                "\nSagsnummer: " + getUniqueReportIdentifier();
    }

    @Override
    public String toString() {
        return "RegisterInlineXBRLResponse{" +
                "companyCvr='" + companyCvr + '\'' +
                ", companyName='" + companyName + '\'' +
                ", registrationDate='" + registrationDate + '\'' +
                ", reportPeriod='" + reportPeriod + '\'' +
                ", statusCode='" + statusCode + '\'' +
                ", statusText='" + statusText + '\'' +
                ", statusDetail='" + statusDetail + '\'' +
                ", uniqueReportIdentifier='" + uniqueReportIdentifier + '\'' +
                ", token='" + token + '\'' +
                ", validationErrors=" + Arrays.toString(validationErrors) +
                '}';
    }
}
